"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from gram_ai.types import BaseModel
from gram_ai.utils import (
    FieldMetadata,
    HeaderMetadata,
    QueryParamMetadata,
    SecurityMetadata,
)
import pydantic
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class GetTemplateSecurityOption1TypedDict(TypedDict):
    project_slug_header_gram_project: str
    session_header_gram_session: str


class GetTemplateSecurityOption1(BaseModel):
    project_slug_header_gram_project: Annotated[
        str,
        FieldMetadata(
            security=SecurityMetadata(
                scheme=True,
                scheme_type="apiKey",
                sub_type="header",
                field_name="Gram-Project",
            )
        ),
    ]

    session_header_gram_session: Annotated[
        str,
        FieldMetadata(
            security=SecurityMetadata(
                scheme=True,
                scheme_type="apiKey",
                sub_type="header",
                field_name="Gram-Session",
            )
        ),
    ]


class GetTemplateSecurityOption2TypedDict(TypedDict):
    apikey_header_gram_key: str
    project_slug_header_gram_project: str


class GetTemplateSecurityOption2(BaseModel):
    apikey_header_gram_key: Annotated[
        str,
        FieldMetadata(
            security=SecurityMetadata(
                scheme=True,
                scheme_type="apiKey",
                sub_type="header",
                field_name="Gram-Key",
            )
        ),
    ]

    project_slug_header_gram_project: Annotated[
        str,
        FieldMetadata(
            security=SecurityMetadata(
                scheme=True,
                scheme_type="apiKey",
                sub_type="header",
                field_name="Gram-Project",
            )
        ),
    ]


class GetTemplateSecurityTypedDict(TypedDict):
    option1: NotRequired[GetTemplateSecurityOption1TypedDict]
    option2: NotRequired[GetTemplateSecurityOption2TypedDict]


class GetTemplateSecurity(BaseModel):
    option1: Annotated[
        Optional[GetTemplateSecurityOption1],
        FieldMetadata(security=SecurityMetadata(option=True)),
    ] = None

    option2: Annotated[
        Optional[GetTemplateSecurityOption2],
        FieldMetadata(security=SecurityMetadata(option=True)),
    ] = None


class GetTemplateRequestTypedDict(TypedDict):
    id: NotRequired[str]
    r"""The ID of the prompt template"""
    name: NotRequired[str]
    r"""The name of the prompt template"""
    gram_key: NotRequired[str]
    r"""API Key header"""
    gram_session: NotRequired[str]
    r"""Session header"""
    gram_project: NotRequired[str]
    r"""project header"""


class GetTemplateRequest(BaseModel):
    id: Annotated[
        Optional[str],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""The ID of the prompt template"""

    name: Annotated[
        Optional[str],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""The name of the prompt template"""

    gram_key: Annotated[
        Optional[str],
        pydantic.Field(alias="Gram-Key"),
        FieldMetadata(header=HeaderMetadata(style="simple", explode=False)),
    ] = None
    r"""API Key header"""

    gram_session: Annotated[
        Optional[str],
        pydantic.Field(alias="Gram-Session"),
        FieldMetadata(header=HeaderMetadata(style="simple", explode=False)),
    ] = None
    r"""Session header"""

    gram_project: Annotated[
        Optional[str],
        pydantic.Field(alias="Gram-Project"),
        FieldMetadata(header=HeaderMetadata(style="simple", explode=False)),
    ] = None
    r"""project header"""
